import * as React from 'react';
import { ButtonBaseTypeMap, ExtendButtonBase } from './ButtonBase.types';
export declare const ButtonBaseRoot: React.ElementType<any>;
/**
 * `ButtonBase` contains as few styles as possible.
 * It aims to be a simple building block for creating a button.
 * It contains a load of style reset and some focus/ripple logic.
 *
 * Demos:
 *
 * - [Button](https://mui.com/material-ui/react-button/)
 *
 * API:
 *
 * - [ButtonBase API](https://mui.com/material-ui/api/button-base/)
 */
declare const ButtonBase: ExtendButtonBase<ButtonBaseTypeMap<{}, "button">>;
export default ButtonBase;
